LArSoft - Bug #20685

Bug in ISCalcSeparate::EFieldAtStep
08/27/2018 09:24 AM - Tingjun Yang

Status: Resolved Start date: 08/27/2018
Priority: Normal Due date:

Assignee: Wesley Ketchum % Done: 100%
Category: Estimated time: 0.00 hour
Target version: Spent time: 0.00 hour
Occurs In: Co-Assignees:

Experiment: -

Description

Ajib Paudel found a bug that affects the calculation of the electric field in the simulation when SCE is enabled:
http://nusoft.fnal.gov/larsoft/doxsvn/html/ISCalcSeparate_8cxx_source.html#100209

212 if (£SCE->EnableSimEfieldSCE())

213 {

214 fEfieldOffsets = fSCE->GetEfieldOffsets(geo::Point_t{x,y,z});

215 EField = std::sqgrt( (efield + efield*fEfieldOffsets.X())*(efield + efield*fEfieldOff
sets.X()) +

216 (efield*fEfieldOffsets.Y () +tefield*fEfieldOffsets.Y ()) +

217 (efield*fEfieldOffsets.Z () +efield*fEfieldOffsets.Z()) );

218 }

The last two terms should be:

(efield*fEfieldOffsets.Y () *efield*fEfieldOffsets.Y ()) +
(efield*fEfieldOffsets.Z () *efield*fEfieldOffsets.Z())

| think this bug affected MicroBooNE MCC8 and ProtoDUNE MCC10 and should be fixed as soon as possible.

Lynn, please make sure this bug fix is included in this week's release as we are still preparing ProtoDUNE MCC11. Thanks.

History

#1 - 08/27/2018 10:32 AM - Kyle Knoepfel

- Status changed from New to Assigned

Mike, can this be ready for this week's release?

#2 - 08/27/2018 10:36 AM - Kyle Knoepfel

We encourage you to use a library specially designed for these linear-algebra problems (e.g. SMatrix).

#3 - 08/27/2018 10:38 AM - Tingjun Yang
Mike just pointed out this is the refactored larsim code, which was not used by MicroBooNE MCC8 or ProtoDUNE MCC10.

Apologies for the false alarm.

We still need to fix this for ProtoDUNE MCC11.

#4 - 08/27/2018 10:53 AM - Gianluca Petrillo
Something like:

EField = efield * (geo::Xaxis () + fEfieldOffsets) .R();

should do, except that it assumes electric field along X axis.
To know whether that is correct, access to TPC geometry is required (geo::TPCGeo::DriftDir()), but the service provider interface is not optimised for
http://nusoft.fnal.gov/larsoft/doxsvn/html/ISCalcSeparate_8cxx_source.html#l00209

that.

Also it is necessary to pay attention to the relative sign of the offset and of the drift direction, and the absolute sign of the correction as used
upstream. Just saying.

#5 - 08/27/2018 11:00 AM - Tingjun Yang

- Assignee changed from Michael Mooney to Wesley Ketchum

#6 - 08/27/2018 12:56 PM - Michael Mooney

Note that this does not impact MicroBooNE MCC8 or ProtoDUNE MCC10, as Tingjun mentioned, but also shouldn't impact ProtoDUNE MCC11, as it
does not yet make use of the refactored larsim code.

The original implementation of this feature (authored by me) can be found here:

https://cdcvs.fnal.gov/redmine/projects/larsim/repository/revisions/develop/entry/larsim/LArG4/ISCalculation.cxx

The bug pointed out by Tingjun was introduced by Wes Ketchum, who has now been assigned the ticket. | think he has already created a feature
branch with the fix.

#7 - 08/27/2018 01:40 PM - Lynn Garren

Wes, can the change simply be merged with develop?
Lynn

#8 - 08/28/2018 11:31 AM - Lynn Garren

- Status changed from Assigned to Resolved

- % Done changed from 0 to 100

Since the feature branch was merged into larsoft vO7_03_00 last week, | tested this change against the head of develop. The unit tests are fine
except for ubana, which is broken for other reasons. This change is now in the head of develop and will be included in this weeks' larsoft release.
